﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Perforce.P4;

namespace SampleApp
{
    public class Utilities
    {
        public Connection ConnectToServer(string pUri, out Server pServer, out Repository pRep, Options pOptions = null)
        {
            pServer = new Server(new ServerAddress(pUri));
            pRep = new Repository(pServer);
            Connection con = pRep.Connection;

            con.Connect(pOptions);

            return con;
        }

        public void LoginToServer(Connection pCon, string pUserName, string pClientName, string pPassword, out Credential pCred, Options pOptions = null)
        {
            pCon.UserName = pUserName;
            pCon.Client = new Client();
            pCon.Client.Name = pClientName;

            pCred = pCon.Login(pPassword, pOptions, pUserName);
        }

        public Client GetClientMap(string pClientName, Repository pRep, Options pOptions = null)
        {
            Client client = pRep.GetClient(pClientName, pOptions);

            return client;
        }

        public Client SubmitClientMap(Client pClient, Repository pRep)
        {
            Client client;
            client = pRep.UpdateClient(pClient);

            return client;
        }

        public Changelist GetChangelist(Repository pRep, int pID, Options pOptions = null)
        {
            Changelist changelist;

            changelist = pRep.GetChangelist(pID, pOptions);

            return changelist;
        }

        public Changelist UpdateChangelist(Repository pRep, Changelist pChangelist, Options pOptions = null)
        {
            Changelist changelist;

            changelist = pRep.UpdateChangelist(pChangelist, pOptions);

            return changelist;
        }
    }
}
